#include <stdint.h>
#include <stdio.h>
#include <stdint.h>
#include <cuda_runtime.h>
#include <string.h>

namespace raylib { 
  #include <raylib.h> 
}


#include "kernel.cuh"
#include "scene.cuh"
#include "sphere.cuh"
#include "camera.cuh"



int main() {
  //bluuuuugh i'll figure out occupancy later, this res are easy
  //calculated manually for gtx1060 with 20 SM, 1024 threads/SM
  const int res_x = 32 * 20;
  const int res_y = 32 * 20;
  const dim3 blockCount(20, 20);
  const dim3 threadCount(32, 32);

  uint8_t *image_d;
  Color texture_data[res_x * res_y];
  raylib::SetTargetFPS(60);


  //see if GPU is connected (my egpu is finicky)
  {
    int temp_device;
    cudaError_t err;
    if((err = cudaGetDevice(&temp_device)) != cudaSuccess) {
      printf("failed to get device!\nError: %s\n", cudaGetErrorString(err));
      return(1);
    }
  }
  
  raylib::SetTraceLogLevel(raylib::LOG_ERROR);
  raylib::InitWindow(res_x, res_y, "cuda teseteroni");
  
  //TODO could probably cut out
  raylib::Image image = raylib::GenImageColor(res_x, res_y, raylib::BLUE);
  raylib::Texture tex = raylib::LoadTextureFromImage(image);

  //initilize scene
  Scene scene;
  Sphere sp1 = Sphere(make_vect3(0, -2, 5));
  Sphere sp2 = Sphere(make_vect3(2, 0, 5));
  Camera cam = Camera(1, make_float3(0,0,0));

  while(!raylib::WindowShouldClose()) {
    cudaError_t err;
    //cuda stuff
    cudaMalloc((void **)&image_d, res_x * res_y * sizeof(Color));
    render<<<blockCount, threadCount>>>(image_d); 
    if((err = cudaGetLastError()) != cudaSuccess) {
      printf("kernel did not launch! Error: %s\n", cudaGetErrorString(err));
    }
    cudaDeviceSynchronize();
    cudaMemcpy(texture_data, (void **)image_d, res_x * res_y * sizeof(Color), cudaMemcpyDeviceToHost);

    raylib::BeginDrawing();
    raylib::ClearBackground(raylib::BLACK);
    raylib::UpdateTexture(tex, texture_data);
    raylib::DrawTexture(tex, 0, 0, raylib::WHITE);
    raylib::DrawFPS(0, 0);
    raylib::EndDrawing();
  }
  return 0;
}
