#ifndef SCENE_H
#define SCENE_H

#include "common.cuh"
#include "render_object.cuh"
#include "sphere.cuh"
#include "include/helper_math.h"
//#include "camera.cuh"
#include <stdint.h>

class Camera;

//when we get animations with multiple scenes, we'll make this a virtual function
//with array of DE objects and cam
class Scene {
  const int max_bounces = 10;
  public:
    __device__ Render_object *raycast(struct Ray ray);
    __device__ Render_object **get_objects() { return objs; }
    __device__ Camera *get_camera() { return active_cam; }
  private:
    Sphere sp1 = Sphere(make_vect3(0, -2, 5)); //TODO move to it's own file or whatever
    Sphere sp2 = Sphere(make_vect3(2, 0, 5)); //do some like "add_object" function or somethin
  protected:
    //idk why I need to specify the size... why can't the compiler figure that out?
    Render_object *objs[3] = {&sp1, &sp2, nullptr};
    Camera *active_cam;
    uint8_t *image;
};

#endif
